/***************************************************************************
 *   Copyright (C) 2004-2011 by Johan Maes -ON4QZ                          *
 *   on4qz@telenet.be   http://users.telenet.be/on4qz                      *
 *   http://users.telenet.be/on4qz                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LOCATION_H
#define LOCATION_H
#include <math.h>

#include <QString>



#define FIELD_WIDTH     20.0                    /* A - R */
#define FIELD_HEIGHT    10.0                    /* A - R */
#define SQUARE_WIDTH    (FIELD_WIDTH / 10.0)    /* 0 - 9 */
#define SQUARE_HEIGHT   (FIELD_HEIGHT / 10.0)   /* 0 - 9 */
#define SUB_WIDTH       (SQUARE_WIDTH / 24.0)   /* A - X */
#define SUB_HEIGHT      (SQUARE_HEIGHT / 24.0)  /* A - X */
#define SUB_SUB_WIDTH   (SUB_WIDTH / 10.0)      /* 0 - 9 */
#define SUB_SUB_HEIGHT  (SUB_HEIGHT / 10.0)     /* 0 - 9 */

// WSG84

#define ERAD 6378.137
#define FLATTENING 1.0/298.257223563 
#define EARTHCIRC (ERAD*2*M_PI)

/**
  *@author johan maes
*/

double RAD(double angle);
double DEG(double angle);

bool locatorToLL(QString loc, double &latitude, double &longitude);
bool LLToLocator(double latitude, double longitude, QString &str);
void calcDistanceBearing(double lat1, double lon1, double lat2, double lon2, double &bearing, double &distance);
void convertToDMS(double x, int &d,int &m, int &s);
double convertFromDMS(int d,int m, int s);
double dist(double lat1, double lon1, double lat2,double lon2);
bool LLToADIFString(double latitude, double longitude, QString &strLat,QString &strLon);
bool stringADIFToLL(double &latitude, double &longitude,QString strLat,QString strLon);
void degreeToADIFString(double dg,QString &strCoordinate);
void stringADIFToDegree(double &dg,QString strCoordinate);
void stringToDM_Degree(QString &result,QString s);
#endif
