/***************************************************************************
 *   Copyright (C) 2004-2011 by Johan Maes -ON4QZ                          *
 *   on4qz@telenet.be   http://users.telenet.be/on4qz                      *
 *   http://users.telenet.be/on4qz                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QPixmap>
#include <QLineEdit>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void readSettings();
    void writeSettings();
    void closeEvent(QCloseEvent *event);

private slots:
 void slotMilesChanged(bool inMiles);
 void slotClear();
 void slotExit();
 void slotLocHomeChanged();
 void slotLocRemoteChanged();
 void slotLLToLocator();
 void slotLocatorToLL();
 void slotConfigure();
 void slotAboutQGrid();
 void slotAboutQt();

 private:



private:
    Ui::MainWindow *ui;
    void drawCompass(double degrees);
    QPixmap arrowPixmap;
    QPixmap compassPixmap;
    int side;
    QColor needleColor;
    QColor needleTopColor;

    QString homeLocator;
    QString remoteLocator;
    bool validateLocator(const QString loc);
    bool validateLocator(QLineEdit *le);
    void setParams();
    void setInt(QLineEdit *ql,int x);
    void setDouble(QLineEdit *ql,double x);
};

#endif // MAINWINDOW_H
